//+------------------------------------------------------------------+
//|                                        Indicator_Environment.mq4 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#include <Quantum-Prop.mqh>
#include <Quantum-Prop-Local.mqh>
#include <Quantum-Prop-Include.mqh>

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Lime
//--- buffers
double ExtMapBuffer1[];

extern int near   = 5;
extern int far    = 20;
extern int period = 120;

double open[], high[], low[], close[], price[], data[QP_STATS_NUM_STATS]; 
int price_bars;
datetime last_bar;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
       switch(UninitializeReason())
       {
        case 0:
            Print("UNINIT reason: Script finished its execution independently.");
            break;
        case REASON_CHARTCLOSE:
            Print("UNINIT reason: Chart closed.");
            break;
        case REASON_REMOVE:
            Print("UNINIT reason: Expert removed from chart.");
            break; // cleaning up and deallocation of all resources.
        case REASON_RECOMPILE:
            Print("UNINIT reason: Expert recompiled.");
            break;
        case REASON_CHARTCHANGE:
            Print("UNINIT reason: symbol or timeframe changed on the chart.");
            break;
        case REASON_PARAMETERS:
            Print("UNINIT reason: Inputs parameters was changed by user.");
            break;
        case REASON_ACCOUNT:
            Print("UNINIT reason: Other account activated.");
            break;  // prepare to restart
        default:
            Print("UNINIT reason: Unknown UNINIT reason ["+UninitializeReason()+"]");
       }  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
//----
   int i, limit, ret;
   double info[QP_CROSS_NUM_CROSS];
   
   if(counted_bars>0) 
   {
      counted_bars--;
   } else
   {
      ArrayResize(open,   Bars+1);
      ArrayResize(high,   Bars+1);
      ArrayResize(low,    Bars+1);
      ArrayResize(close,  Bars+1);
      ArrayResize(price,  Bars+1);
      last_bar = 0;
      Print("counted bars <= 0, Bars: "+Bars);
   }

   if( last_bar != Time[0] )
   {
      for(i=0;i<Bars;i++)
      {  
         open[i]    = Open[i];
         high[i]    = High[i];
         low[i]     = Low[i];
         close[i]   = Close[i];
         price[i]   = (Open[i] + High[i] + Low[i] + Close[i]) / 4;
         price_bars = i;
      
         if( Time[i] - Time[i+1] > 6 * 60 * Period() )// Gap in the data
            break;
      }   
   }
   
   open[0]    = Open[0];
   high[0]    = High[0];
   low[0]     = Low[0];
   close[0]   = Close[0];
   price[0]   = (Open[0] + High[0] + Low[0] + Close[0]) / 4;
      
   limit=Bars-counted_bars;
   for(i=0;i<limit;i++)
   {
      if( Bars - i < 200 ) break;
                          
      
       ret = QP_MA_Environment(price, price_bars, period, near, far, info, i); 
       
       switch (ret){
       case QP_MAE_UP:
         ExtMapBuffer1[i] = -1;
         break;
       case QP_MAE_DOWN: 
         ExtMapBuffer1[i] = 1;
         break;
       case QP_MAE_FLAT:
         ExtMapBuffer1[i] = 2;
         break;
         default:
         ExtMapBuffer1[i] = 0;
       }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+